using System.Linq;
using System.Diagnostics;
using ttrss_co_client.ttrss;
using ttrss_co_client.ttrss.datastructures;

namespace ttrss_co_client.tasks
{
    ///<summary>Move to output</summary>
    public class Publish : Phase2Task
    {
        public override string TaskName => "filemovePublish";
        public override async Task<Tuple<TaskStatus, WorkOrder>>ActOn(WorkOrder workOrder)
        {
            var targetDirectory = Path.GetDirectoryName(workOrder.data["publish-target"]);
            if(!Directory.Exists(targetDirectory))
            {
                Directory.CreateDirectory(targetDirectory);
            }
            File.Move(workOrder.data["path"], workOrder.data["publish-target"], true);
            var article = (await TtrssClient.GetArticles(workOrder.articleId))?.FirstOrDefault();
            await TtrssClient.UpdateArticleNote($"{article.note}\n[{DateTime.Now.ToShortDateString()}] - copied", article.id);
            return new Tuple<TaskStatus, WorkOrder>(TaskStatus.Done, workOrder);
        }
    }
} 